Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
-  trait PatternMatching extends SubComponent with Transform with TypingTransformers with Debugging with Interface with MatchTranslation with MatchTreeMaking with MatchCodeGen with MatchCps with ScalaLogic with Solving with MatchAnalysis with MatchOptimization with MatchWarnings with PatternExpansion

  Translate pattern matching.

  Translate pattern matching.

  Either into optimized if/then/else's, or virtualized as method calls (these methods form a zero-plus monad), similar in spirit to how for-comprehensions are compiled.

  For each case, express all patterns as extractor calls, guards as 0-ary extractors, and sequence them using `flatMap` (lifting the body of the case into the monad using `one`).

  Cases are combined into a pattern match using the `orElse` combinator (the implicit failure case is expressed using the monad's `zero`).

  TODO:

  - DCE (on irrefutable patterns)
  - update spec and double check it's implemented correctly (see TODO's)

  (longer-term) TODO:

  - user-defined unapplyProd
  - recover GADT typing by locally inserting implicit witnesses to type equalities derived from the current case, and considering these witnesses during subtyping (?)
  - recover exhaustivity/unreachability of user-defined extractors by partitioning the types they match on using an HList or similar type-level structure
  Definition Classes
    patmat
- CNF
- CODE
- CheckableTreeAndTypeAnalysis
- CodegenCore
- CommonSubconditionElimination
- ExtractorAlignment
- ExtractorSubPatternAlignment
- MatchAnalyzer
- MatchApproximator
- MatchMonadInterface
- MatchOptimizer
- MatchTransformer
- MatchTranslator
- OptimizedCodegen
- OptimizingMatchTranslator
- Phase
- PropositionalLogic
- Solver
- StdPhase
- Suppression
- SwitchEmission
- ThicketTransformer
- TreeMakerWarnings
- TreeMakers
- TreesAndTypesDomain
- TypedSubstitution
- TypingTransformer
- debug
- vpmName

c

scala.tools.nsc.transform.patmat.PatternMatching

# MatchTransformer

###

#### class MatchTransformer extends TypingTransformer

Source
  PatternMatching.scala

Linear Supertypes
PatternMatching.TypingTransformer, Global.Transformer, Global.InternalTransformer, Global.Transformer, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. MatchTransformer
2. TypingTransformer
3. Transformer
4. InternalTransformer
5. Transformer
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new MatchTransformer(unit: Global.CompilationUnit)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from MatchTransformer toany2stringadd[MatchTransformer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (MatchTransformer, B)
   Implicit
     This member is added by an implicit conversion from MatchTransformer toArrowAssoc[MatchTransformer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def atOwner[A](tree: Global.Tree, owner: Global.Symbol)(trans: => A): A
   Definition Classes
     TypingTransformer
8.  final def atOwner[A](owner: Global.Symbol)(trans: => A): A
   Definition Classes
     TypingTransformer → Transformer
9.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
10.  var curTree: Global.Tree
    Attributes
      protected
    Definition Classes
      TypingTransformer
11.  def currentClass: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
12.  def currentMethod: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
13.  var currentOwner: Global.Symbol
    Attributes
      protected[scala]
    Definition Classes
      Transformer
14.  def ensuring(cond: (MatchTransformer) => Boolean, msg: => Any): MatchTransformer
    Implicit
      This member is added by an implicit conversion from MatchTransformer toEnsuring[MatchTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: (MatchTransformer) => Boolean): MatchTransformer
    Implicit
      This member is added by an implicit conversion from MatchTransformer toEnsuring[MatchTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean, msg: => Any): MatchTransformer
    Implicit
      This member is added by an implicit conversion from MatchTransformer toEnsuring[MatchTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean): MatchTransformer
    Implicit
      This member is added by an implicit conversion from MatchTransformer toEnsuring[MatchTransformer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
19.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
20.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
21.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from MatchTransformer toStringFormat[MatchTransformer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
22.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
23.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
24.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
25.  var localTyper: (analyzer)#Typer
    Definition Classes
      TypingTransformer
26.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
27.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
28.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
29.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
30.  def toString(): String
    Definition Classes
      AnyRef → Any
31.  def transform(tree: Global.Tree): Global.Tree
    Definition Classes
      MatchTransformer → TypingTransformer → InternalTransformer → Transformer
32.  def transformAtOwner(owner: Global.Symbol, tree: Global.Tree): Global.Tree
    Definition Classes
      TypingTransformer
33.  def transformCaseDefs(trees: List[Global.CaseDef]): List[Global.CaseDef]
    Definition Classes
      Transformer
34.  def transformIdents(trees: List[Global.Ident]): List[Global.Ident]
    Definition Classes
      Transformer
35.  def transformMemberDefs(trees: List[Global.MemberDef]): List[Global.MemberDef]
    Definition Classes
      Transformer
36.  def transformModifiers(mods: Global.Modifiers): Global.Modifiers
    Definition Classes
      Transformer
37.  def transformStats(stats: List[Global.Tree], exprOwner: Global.Symbol): List[Global.Tree]
    Definition Classes
      Transformer
38.  def transformTemplate(tree: Global.Template): Global.Template
    Definition Classes
      Transformer
39.  def transformTrees(trees: List[Global.Tree]): List[Global.Tree]
    Definition Classes
      Transformer
40.  def transformTypeDefs(trees: List[Global.TypeDef]): List[Global.TypeDef]
    Definition Classes
      Transformer
41.  def transformUnit(unit: Global.CompilationUnit): Unit
    Definition Classes
      Transformer
42.  def transformValDef(tree: Global.ValDef): Global.ValDef
    Definition Classes
      Transformer
43.  def transformValDefs(trees: List[Global.ValDef]): List[Global.ValDef]
    Definition Classes
      Transformer
44.  def transformValDefss(treess: List[List[Global.ValDef]]): List[List[Global.ValDef]]
    Definition Classes
      Transformer
45.  def translator(selectorPos: Global.Position): PatternMatching.MatchTranslator with PatternMatching.CodegenCore
46.  val treeCopy: Global.TreeCopier
    Definition Classes
      Transformer
47.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
48.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
49.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (MatchTransformer, B)
   Implicit
     This member is added by an implicit conversion from MatchTransformer toArrowAssoc[MatchTransformer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from PatternMatching.TypingTransformer

### Inherited from Global.Transformer

### Inherited from Global.InternalTransformer

### Inherited from Global.Transformer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromMatchTransformer to any2stringadd[MatchTransformer]

### Inherited by implicit conversion StringFormat fromMatchTransformer to StringFormat[MatchTransformer]

### Inherited by implicit conversion Ensuring fromMatchTransformer to Ensuring[MatchTransformer]

### Inherited by implicit conversion ArrowAssoc fromMatchTransformer to ArrowAssoc[MatchTransformer]

### Ungrouped